class MTel expands KeyPoint;

var Teleporter MyT;

event PostBeginPlay()
{
	DoSetup();
}

function DoSetup()
{
	if (Teleporter(Owner) != None)
	{
		MyT = Teleporter(Owner);
		log (Self$" succesfully got Teleporter "$MyT);
		SetCollisionSize(MyT.CollisionRadius+1,MyT.CollisionHeight+1);
	}
}

event Touch( Actor Other )
{
	local Teleporter T;

//	log (Self$" touched by "$Other.GetHumanName());
	if ( MyT != None )
	{
		MyT.SetCollision(False,False,False);
		SetTimer(0.5,False);
		foreach AllActors (class'Teleporter',T)
		{
			if ( string(MyT.tag)~= T.URL && T.bCollideActors)
				T.SetCollision(False,False,False);
		}
		if ( Other.bIsPawn && VSize(Other.Velocity) < 50)
			DoKick(Other);
	}
}

function DoKick(Actor Other)
{
	local bool bWasFalling, bRandomize, bKillVelocity;
	local vector Push;
	local float PMag;
	local vector KickVelocity;

	KickVelocity.X = 0;
	KickVelocity.Y = 0;
	KickVelocity.Z += 320;
	bRandomize = True;
	bKillVelocity = True;

	bWasFalling = ( Other.Physics == PHYS_Falling ); //Stupid kicker code bellow ++
	if ( bKillVelocity )
		Push = -1 * Other.Velocity;
	else
		Push.Z = -1 * Other.Velocity.Z;
	if ( bRandomize )
	{
		PMag = VSize(KickVelocity);
		Push += PMag * Normal(KickVelocity + 0.5 * PMag * VRand());
	}
	else
		Push += KickVelocity;
	if ( Other.IsA('Bot') )
	{
		if ( bWasFalling )
		{
			Bot(Other).bJumpOffPawn = True;
			Bot(Other).SetFall();
		}
	}
	if ( !Other.Region.Zone.bWaterZone )	// ADD: Reason -> For sure we don't fall in water, you just fuck Bot here, you "smart genius" !!
		Other.SetPhysics(PHYS_Falling);		// You could not code properly 5 classes one by one after all.
	Other.Velocity += Push;
}

event Timer()
{
	local int i;
	local bool bKeepOff;
	local Teleporter T;

//	log (Self$" timer working");
	if ( MyT != None )
	{
		for (i=0;i<4;i++)
			if ( Touching[i] != None && Pawn(Touching[i]) != None && VSize(Pawn(Touching[i]).Velocity) < 50)
			{
				DoKick(Pawn(Touching[i]));
				bKeepOff = True;
			}
		if (bKeepOff)
		{
			SetTimer(0.5,False);
			return;
		}
		else
		{
			MyT.SetCollision(True,False,False);
			foreach AllActors (class'Teleporter',T)
			{
				if ( string(MyT.tag)~= T.URL && !T.bCollideActors)
					T.SetCollision(True,False,False);
			}
		}
	}
}

event UnTouch( Actor Other )
{
	local Pawn P;
	local bool bIsHere;
	local Teleporter T;

//	log(Self$" untouched by "$Other.GetHumanName());
	if (MyT != None)
	{
		foreach RadiusActors (class 'Pawn',P,CollisionRadius+15)
		{
			bIsHere = True;
			break;
		}
		if (bIsHere)
		{
			if ( Other.bIsPawn && VSize(Other.Velocity) < 50)
			{
				foreach AllActors (class'Teleporter',T)
				{
					if ( string(MyT.tag)~= T.URL && T.bCollideActors)
						T.SetCollision(False,False,False);
				}
				MyT.SetCollision(False,False,False);
				SetTimer(0.3,False);
				DoKick(Other);
			}
		}
	}
}

defaultproperties
{
   bGameRelevant=True
   bMovable=False
   bStatic=False
   bCollideActors=True
}